/** JOYCE PCW emulator for UNIX ******************************/
/**                                                         **/
/** JoyceGtk.c: Interface to the GTK+ file selection widget **/
/**                                                         **/
/** Copyright (c) John Elliott 1996-1999                    **/
/**     You are not allowed to sell this software for       **/
/**     profit.                                             **/   
/*************************************************************/

#include "Joyce.h"
#include <gtk/gtk.h>

static int chosen = 0;
static char fname[160];
static int pipefd[2];

/* Get the selected filename and print it to the console */
static void file_ok_sel (GtkWidget *w, GtkFileSelection *fs)
{
    chosen = 1;
    strncpy(fname, gtk_file_selection_get_filename (GTK_FILE_SELECTION (fs)), 159);
    fname[159] = 0;
    write(pipefd[1], fname, 160);
    gtk_widget_destroy(GTK_WIDGET(fs));
}

static void destroy (GtkWidget *widget, gpointer data)
{
    if (!chosen)
    { 
             strcpy(fname, "*");
             write(pipefd[1], fname, 160);
             chosen = 1;
    }
    gtk_main_quit ();
}


void itemsel_main(char *pattern)
{
    int argc = 1;
    char *pargv;
    char **argv;
    GtkWidget *filew;

    pargv = "xjoyce";
    argv  = &pargv;
 
    gtk_init (&argc, &argv);

    strcpy(fname, "*");	/* None */
    
    /* Create a new file selection widget */
    filew = gtk_file_selection_new ("File selection");
    
    gtk_signal_connect (GTK_OBJECT (filew), "destroy",
			(GtkSignalFunc) destroy, &filew);
    /* Connect the ok_button to file_ok_sel function */
    gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION (filew)->ok_button),
			"clicked", (GtkSignalFunc) file_ok_sel, filew );
    
    /* Connect the cancel_button to destroy the widget */
    gtk_signal_connect_object (GTK_OBJECT (GTK_FILE_SELECTION (filew)->cancel_button),
			       "clicked", (GtkSignalFunc) gtk_widget_destroy,
			       GTK_OBJECT (filew));
    
    /* Lets set the filename, as if this were a save dialog, and we are giving
     a default filename */
    gtk_file_selection_set_filename (GTK_FILE_SELECTION(filew), 
				     pattern);
    
    gtk_widget_show(filew);
    chosen = 0;
    gtk_main ();

    exit(0);
}



char *Itemsel(char *pattern)
{
        static char fname[160];
	int status, pid;

        /* We don't start the GTK event loop until we need a file selector.
          And since the GTK event loop can only be started once, but we want
          multiple file selectors, we fork() off a separate selector and
          communicate with it using pipe(). Yes, it's a hack. */

        if (pipe(pipefd)) return NULL;

	pid = fork();
        if (!pid) itemsel_main(pattern);    /* Does not return */
        else
        {
                read(pipefd[0], fname, 160);
		waitpid(pid, &status, 0);
        }
        if (fname[0] == '*') return NULL;
        return fname;
}

