#include <SDL.h>

/* SDL_MapSurface is not present in versions > 0.8 */

#if SDL_MINOR_VERSION > 8
	#define SDL_MapSurface(x, y)
#endif

#ifdef SCRMOD
	SDL_Surface *screen   = NULL;
	SDL_Surface *framebuf = NULL;
	SDL_Surface *context  = NULL;
        SDL_Color *colours;
	int mustlock;	
	int ncolours;
	int tracking = 0;
#else
	extern SDL_Surface *screen;
	extern SDL_Surface *framebuf;
	extern SDL_Surface *context;
	extern SDL_Color   *colours;
	extern int mustlock;
	extern int ncolours;	
	extern int tracking;
#endif	/* SCRMOD */

void GrBoxNC(int x1, int y1, int x2, int y2, int colour);
void GrHLineNC(int x1,int x2,int y, int c);
void GrVLineNC(int x,int y1,int y2, int c);
void GrFilledBoxNC(int x1, int y1, int x2, int y2, int colour);
void GrFilledBox(int x1, int y1, int x2, int y2, int colour);
void GrPlotNC(int x, int y, int colour);
void GrClearScreen(int index);
void GrHLine(int x1,int x2,int y, int c);
void GrVLine(int x,int y1,int y2, int c);
void GrClearClipBox(int colour);
void GrSetClipBox(int x1, int y1, int x2, int y2);
void GrPlot(int x, int y, int colour);
void GrPlotRop(int x1, int y1, int colour, int rop);
void GrLineRop(int x1, int y1, int x2, int y2, int colour, int rop);
void GrQueryColor(int n, int *r, int *g, int *b);
int  GrPixel(int x, int y);

void xor_block(int y, int x, int h, int w);
void SdlScrBlit(int dx, int dy, int sx, int sy, int sx2, int sy2);
void reload_palette(void);
unsigned char get_keytoken(void);
void track_mouse(Uint16 x, Uint16 y);
