/** JOYCE PCW emulator ***************************************/
/**                                                         **/
/** JOYCEFIL.C: Locates files for the emulator to use       **/
/**                                                         **/
/** Copyright (c) John Elliott 1996-1999                    **/
/**     You are not allowed to sell this software for       **/
/**     profit.                                             **/   
/*************************************************************/

#include "Joyce.h"
#include "inline.h"
#include <errno.h>

extern char *joycedir;

#ifdef UNIX

char *gethome(void)
{
	char *s; 

	/* I suppose we should try parsing /etc/passwd in the event that this
          getenv() call fails */

	s = getenv("HOME");	

	if (s == NULL) return ".";
	return s;
}

char *find_joyce_file(char *fname)
{
        static char txt[PATH_MAX];
	DIR *dir;

        sprintf(txt, "%s/%s", gethome(), HOMEROOT);

	dir = opendir(txt);
	if (dir == NULL && errno == ENOENT) mkdir(txt, 0755);
	if (dir != NULL) closedir(dir);

	dir = opendir(txt);
	if (dir == NULL)
	{
		sprintf(txt, "./%s", fname);
		return txt;
	}
	closedir(dir);	
	sprintf(txt, "%s/%s/%s", gethome(), HOMEROOT, fname);   
	return txt; 
}


char *find_boot_file(char *fname)
{
        static char txt[PATH_MAX];
	FILE *fp;

        sprintf(txt, "%s/%s/%s/%s", gethome(), HOMEROOT, BOOT_DIR, fname);
	fp = fopen(txt, "r");
	if (fp) { fclose(fp); return txt; }
	
	sprintf(txt, "%s/%s/%s", LIBROOT, BOOT_DIR, fname);
        return txt;
}

char *find_dsk_file(char *fname)
{
        static char txt[PATH_MAX];
        FILE *fp;

        sprintf(txt, "%s/%s/%s/%s", gethome(), HOMEROOT, DISK_DIR, fname);
        fp = fopen(txt, "r");
        if (fp) { fclose(fp); return txt; }

        sprintf(txt, "%s/%s/%s", LIBROOT, DISK_DIR, fname);
        return txt;
}

#endif /* def UNIX */

#ifdef __MSDOS__

char *find_boot_file(char *fname)
{
	static char txt[160];

	sprintf(txt, "%s/%s/%s", joycedir, BOOT_DIR, fname);
	return txt;
}

char *find_dsk_file(char *fname)
{
        static char txt[160];

        sprintf(txt, "%s/%s/%s", joycedir, DISK_DIR, fname);
        return txt;
}

char *find_joyce_file(char *fname)
{
        static char txt[160];

        sprintf(txt, "%s/%s", joycedir, fname);
        return txt;
}

#endif /* def __MSDOS__ */
