
#ifdef __cplusplus
extern "C" {
#endif

#undef EXTERN

#ifdef SCRMOD	// Main screen module?
	#define EXTERN

	byte scrfont[]={	/* 8x16 font for screen messages */

	#include "font8x16.inc"

	};
#else
	#define EXTERN extern
	extern byte scrfont[];
#endif

/*EXTERN byte BeepType;  (v1.20) Now jset.beep */
EXTERN byte ScrType;		    /* Screen emulation type, 0 => normal */
EXTERN byte ScrEnabled;		    /* Screen enabled? */
EXTERN byte ScInited;		    /* Initialised? */
EXTERN unsigned char *rram_base;    /* Assumes little-endianness */
EXTERN unsigned char y_origin;      /* Top of screen   (OUT 0xF6) */
EXTERN unsigned char colour_reg;    /* Colour register (OUT 0xF7) */
EXTERN short scr_h;                 /* Lines / screen. Can have 200-line screen */
EXTERN int blk,whi,dblk,dwhi;	    /* Colour indexes black, white, default b/w */
EXTERN int beeperstat;		    /* Beeper on? */
EXTERN int colour_nextfree;	    /* Colour to free next */
#ifdef __MSDOS__
EXTERN GrContext FrameContext;	    /* Graphic context for the framebuf */
#endif
EXTERN int vga_x, vga_y;	    /* VGA x and y coordinates for text */
EXTERN byte vga_fg, vga_bg;	    /* fore & background */
EXTERN byte vga_curon, vga_curvis;  /* (v1.22) VGA cursor enabled and/or visible? */
EXTERN char *planes[4];
EXTERN int linelen;		    /* Length of a screen line */
EXTERN int debug_fg, debug_bg;	    /* Index of debug console colours */
EXTERN int text_fg, text_bg;	    /* Index of menu screen colours */
EXTERN int shadow_hi, shadow_lo;    /* Indices of 3d highlight / shadow */
EXTERN int border_beep;		    /* Border beep colour */

EXTERN byte screen_shadow[90][256];	/* (v1.30) The screen shadow holds 
                                         *        the last image (in PCW 
                                         *        mode) painted to the screen.
                                         *        It optimises painting by
                                         *        making it only paint bits
                                         *        that change. 
                                         */
EXTERN byte shadow_invalid;		/* Set to ignore the shadow */


void Border(void);	/* Draw the border in the frame buffer */
void BlitBuf(void);
void SaveBuf(void);
void draw_bitmap(int y, int x, int h, int w, byte *bm, int fg, int bg);

void vga_putchar(byte ch);
void vga_putmch(byte ch);
void vga_setmode(byte mode);
int colour_find(int r, int g, int b);
void set_ink(int *ink, int r, int g, int b);
void vga_cursor(byte on);	/* v1.22 */
void vga_drawcur(void);		/* v1.22 */

void vid_rv(char r);
void vid_putch(char c);
void vid_at(char y,char x);
void vid_puts(char *s);
void vid_putsxy(char y, char x, char *s);
char dgetch(void);

void gsx_cmd(word pb);

char *Itemsel(char *mask);

#ifdef __cplusplus
}
#endif

