/** fMSX: portable MSX emulator ******************************/
/**                                                         **/
/**                         AY8910.h                        **/
/**                                                         **/
/** Declarations for AY8910 Programmable Sound generator.   **/
/**                                                         **/
/** Copyright (C) Alex Krasivsky  1994                      **/
/**               Marat Fayzullin 1995                      **/
/**     You are not allowed to distribute this software     **/
/**     commercially. Please, notify me, if you make any    **/
/**     changes to this file.                               **/
/*************************************************************/

extern byte PSG[16];

void PutAdlib(register byte R,register byte V);
void MuteSound(void);

/*** InitAdlib ***************************************/
/*** Return 0 if Adlib is not found, otherwise     ***/
/*** initialize it and return 1.                   ***/
/*****************************************************/
byte InitAdlib(void);

/*** TrashAdlib **************************************/
/*** If Adlib was used then shut it down.          ***/
/*****************************************************/
void TrashAdlib(void);

/*** ResumeSound *************************************/
/*** Resume sound after MuteSound.                 ***/
/*****************************************************/
void ResumeSound(void);

/*** PSGOut ******************************************/
/*** Write value V into AY8910 register R.         ***/
/*** Appropriate sound routines are called as it   ***/
/*** is done.                                      ***/
/*****************************************************/
void PSGOut(register byte R,register byte V);

void AYPort(register byte P, register byte V);
