
/* Inlines (if any) for the Z80 emulator */


extern unsigned char *PCWRAM,	 /* The memory */
		     *PCWRD[4],  /* Read pointers to the four banks */
		     *PCWWR[4],  /* Write pointers to the four banks */
		     bank_lock[4]; /* Force R/W to the same bank? */

#ifdef __cplusplus
extern "C" {
#endif

extern __inline__ byte RdZ80(word addr)
{
	return (PCWRD[addr>>14])[addr];
}


extern __inline__ void WrZ80(word addr,byte v)
{
	(PCWWR[addr>>14])[addr]=v;
}


extern __inline__ word RdWord(word addr)
{
	return (((word)RdZ80(addr + 1)) << 8) | RdZ80(addr);
}


extern __inline__ void WrWord(word addr, word value)
{
	WrZ80(addr++, (value & 0xff));
	WrZ80(addr--, (value >> 8));
}

#ifdef __cplusplus
}
#endif

