
#include "Joyce.h"
#include "Joycevga.h"
#include "Joycemou.h"
#include "keyboard.h"
#include <assert.h>

////////////////////////////////////////////////////////////////////////
// The dummy functions come in two categories...
//
// Stubs for calls that haven't yet been implemented
// Calls that don't do anything in the Unix version

// Stubs...

#define false 0

void gsx_cmd(word pb) { assert(false); }




////////////////////////////////////////////////////////////////////////
// Raw screen access
//

void cputs(char *s) { fputs(s, stderr); }
char getch(void) { return getchar(); }

////////////////////////////////////////////////////////////////////////
// Sound no-ops. If SDL is capable of emulating an AY-3-8910 
// portably, this is where it would get initialised & deinitialised.

byte InitAdlib(void)
{
	return 0;	/* No sound card */
}

void TrashAdlib(void)
{
			/* No sound card */
}

void AYPort(register byte P, register byte V)
{
	(void)P;
	(void)V;
}

//////////////////////////////////////////////////////////////////////
//
// Code to use when debugging

__inline__ byte RdZ80(word addr)
{
        return (PCWRD[addr>>14])[addr];
}


__inline__ void WrZ80(word addr,byte v)
{
        (PCWWR[addr>>14])[addr]=v;
}


__inline__ word RdWord(word addr)
{
        return (((word)RdZ80(addr + 1)) << 8) | RdZ80(addr);
}


__inline__ void WrWord(word addr, word value)
{
        WrZ80(addr++, (value & 0xff));
        WrZ80(addr--, (value >> 8));
}

